#line 1 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
#line 1 "c:/users/richard/desktop/workdir/thermo_k/example/avr/mcp9600.h"
#line 3 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
sbit LCD_RS at PORTA2_bit;
sbit LCD_EN at PORTD6_bit;
sbit LCD_D4 at PORTC4_bit;
sbit LCD_D5 at PORTC5_bit;
sbit LCD_D6 at PORTC6_bit;
sbit LCD_D7 at PORTC7_bit;

sbit LCD_RS_Direction at DDA2_bit;
sbit LCD_EN_Direction at DDD6_bit;
sbit LCD_D4_Direction at DDC4_bit;
sbit LCD_D5_Direction at DDC5_bit;
sbit LCD_D6_Direction at DDC6_bit;
sbit LCD_D7_Direction at DDC7_bit;

char tk_status;
char txt[10];
char lab1[10];
char old_txt[10];
char tmp_data[10];
char Temp_Data_Ready;
#line 31 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
char Write_MCP9600_Data(char RegAddr, char _data)
{
 tmp_data[0] = RegAddr;
 tmp_data[1] = _data;

 TWI_Start();
 TWI_Write(  0xC0  );
 TWI_Write( tmp_data[ 0 ] );
 TWI_Write( tmp_data[ 1 ] );
 TWI_Stop();
}
#line 50 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
char Read_MCP9600_Data( char RegAddr )
{
 tmp_data[0] = RegAddr;

 TWI_Start();
 TWI_Write(  0xC0  );
 TWI_Write( tmp_data[ 0 ] );
 TWI_Stop();
 Delay_us( 50 );
 TWI_Start();
 TWI_Write(  0xC0  | 1 );
 tmp_data[ 0 ] = TWI_Read( 0 );
 TWI_Stop();

 return tmp_data[0];
}
#line 74 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
char Read_MCP9600_Status()
{
 char DataSum;

 tmp_data[0] =  0x04 ;

 TWI_Start();
 TWI_Write(  0xC0  );
 TWI_Write( tmp_data[ 0 ] );
 TWI_Stop();
 Delay_us( 50 );
 TWI_Start();
 TWI_Write(  0xC0  | 1 );
 tmp_data[ 0 ] = TWI_Read( 0 );
 TWI_Stop();
 DataSum = tmp_data[0];

 return DataSum;
}
#line 101 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
float Read_Temperature()
{
 float Temperature;

 tmp_data[0] =  0x00 ;

 TWI_Start();
 TWI_Write(  0xC0  );
 TWI_Write( tmp_data[ 0 ] );
 TWI_Stop();
 Delay_us( 50 );
 TWI_Start();
 TWI_Write(  0xC0  | 1 );
 tmp_data[ 0 ] = TWI_Read( 1 );
 tmp_data[ 1 ] = TWI_Read( 0 );
 TWI_Stop();

 if((tmp_data[0] & 0x80) == 0x80){
 tmp_data[0] = tmp_data[0] & 0x7F;
 Temperature = 1024 - (tmp_data[0]*16 + tmp_data[1] / 16);
 }
 else
 Temperature = (tmp_data[0] * 16 + (float)tmp_data[1] / 16);

 return Temperature;
}
#line 135 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/AVR/THERMO_K_click.c"
void updateLabel(char *newText, int x, int y, char* lbl)
{
 Lcd_Out( 2, 5, newText );
}




void main()
{
 char res;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out( 1, 2, "Thermo K click" );
 TWI_Init( 100000 );
 Delay_ms( 200 );

 while(1){
 tk_status = &Read_MCP9600_Status;
 Temp_Data_Ready = ( tk_status & 0x40 );

 if (Temp_Data_Ready){
 sprintf(txt, "%2.1f C", Read_Temperature());
 res = strcmp(txt,old_txt);

 if(res != 0){
 updateLabel(txt, 135, 90, lab1);
 strcpy(old_txt,txt);
 }
 }
 Delay_ms(500);
 }
}
